#include <netinet/in.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <time.h>
#include <netdb.h>
#include <errno.h>
#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <unistd.h>
#include <pcap.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include "byteorder.h"
#include "systype.h"
#include <netinet/ip_icmp.h>
#include <netinet/ip.h>
#ifndef __u8
#define __u8            u_int8_t
#endif				/* __u8 */
#ifndef __u16
#define __u16           u_int16_t
#endif				/* __u16 */
#ifndef __u32
#define __u32           u_int32_t
#endif				/* __u32 */

#ifndef __uint8_t
#define __uint8_t       u_int8_t
#endif				/* __uint8_t */
#ifndef __uint16_t
#define __uint16_t      u_int16_t
#endif				/* __uint16_t */
#ifndef __uint32_t
#define __uint32_t      u_int32_t
#endif				/* __uint32_t */
/* protocols header size */
#ifndef ICMPHDR_SIZE
#define ICMPHDR_SIZE    sizeof(struct myicmphdr)
#endif
#ifndef UDPHDR_SIZE
#define UDPHDR_SIZE     sizeof(struct myudphdr)
#endif
#ifndef TCPHDR_SIZE
#define TCPHDR_SIZE     sizeof(struct mytcphdr)
#endif
#ifndef IPHDR_SIZE
#define IPHDR_SIZE      sizeof(struct myiphdr)
#endif
/* fragmentation stuffs */
#define MF ((unsigned short)0x2000)	/* more fragments */
#define DF ((unsigned short)0x4000)	/* dont fragment */
#define NF ((unsigned short)0x0000)	/* no more fragments */
#ifndef TH_FIN
#define TH_FIN  0x01
#endif
#ifndef TH_SYN
#define TH_SYN  0x02
#endif
#ifndef TH_RST
#define TH_RST  0x04
#endif
#ifndef TH_PUSH
#define TH_PUSH 0x08
#endif
#ifndef TH_ACK
#define TH_ACK  0x10
#endif
#ifndef TH_URG
#define TH_URG  0x20
#endif
#ifndef TH_X
#define TH_X 0x40		/* X tcp flag */
#endif
#ifndef TH_Y
#define TH_Y 0x80		/* Y tcp flag */
#endif
struct mytcphdr {
    __u16 th_sport;		/* source port */
    __u16 th_dport;		/* destination port */
    __u32 th_seq;		/* sequence number */
    __u32 th_ack;		/* acknowledgement number */
#if defined (__LITTLE_ENDIAN_BITFIELD)
    __u8 th_x2:4,		/* (unused) */
     th_off:4;			/* data offset */
#elif defined (__BIG_ENDIAN_BITFIELD)
    __u8 th_off:4,		/* data offset */
     th_x2:4;			/* (unused) */
#else
#error  "Please, edit Makefile and add -D__(LITTLE|BIG)_ENDIAN_BITFIEND"
#endif
    __u8 th_flags;
    __u16 th_win;		/* window */
    __u16 th_sum;		/* checksum */
    __u16 th_urp;		/* urgent pointer */
};
struct tcpports{
	unsigned int ftp;    
	unsigned int telnet;
	unsigned int smtp;  
	unsigned int http;  
	unsigned int pop3;  
	unsigned int https;  
	unsigned int others;
};
struct udpports{
	unsigned int dns;
	unsigned int tftp;
	unsigned int others;
};
struct icmptypes{
	unsigned int echoreply;
	unsigned int dest_unreach;
	unsigned int source_quench;
	unsigned int redirect;
	unsigned int echo;
	unsigned int time_exceeded;
	unsigned int parameterprob;
	unsigned int timestamp;
	unsigned int info_request;
	unsigned int timestampreply;
	unsigned int info_reply;
	unsigned int addrmask_req;
	unsigned int addrmask_repl;
	unsigned int others;
};
//Prototypes and Global Variables
#define BGP_PORT 179
#define RIP_PORT 521
pcap_handler handlepkt(u_char *, struct pcap_pkthdr *, u_char *);
char *copy_argv(register char **argv);
void usage(char *proggie);
int daemonize(void);
void counttcp(unsigned int source,unsigned int dest);
void countudp(unsigned int source,unsigned int dest);
void counticmp(unsigned int types);
unsigned int calc(unsigned int total,unsigned int ttotal);
struct pcap_stat st;
struct tcpports ourtcp;
struct udpports ourudp;
struct icmptypes ouricmp;
void closeup(int);
char *sniff_time(void);
int lupatinadora,fdhandle,verbose,status;
u_short ETHHDRSIZE;
FILE *fd;
pcap_t *pd;
//pcap_dumper_t *pd_dump = NULL;
