/*
  GetData Next Generation, network sniffer and protocol analyzer
  by Victor Pereira [<vpereira@modulo.com.br>]|[<vpereira@hostname.org>]
*/

#ifndef lint
static const char copyright[] = "nham nham nham ($$$$$$$$$)";
static const char rcsid[] =
    "@(#) $Header: getdata.c, v 1.1 2002/06/19 11:56:57";
static const char disclaimer[] = "I see nerd people";
#endif

//#include <netinet/in.h>
//#include <sys/socket.h>
//#include <arpa/inet.h>
//#include <netinet/ip.h>
//#include <linux/tcp.h>
//#include <linux/icmp.h>
#include "general.h"
#include <linux/udp.h>
#include <linux/igmp.h>
#define  VER "1.1NG"


int main(int argc, char *argv[])
{
    bpf_u_int32 localnet, netmask;
    char errbuf[PCAP_ERRBUF_SIZE];
    char *device = NULL;
    char *file = NULL;
    char *xpr;
    extern char *optarg;
    extern int optind;
    struct bpf_program fcode;
    char ch;
    int become_daemon=0;
    
    if (getuid() != 0) {
	printf("Got Root ?!\n");
	exit(0);
    }


    while ((ch = getopt(argc, argv, "i:dsvho:")) != EOF) {
	switch (ch) {
	case 'i':
	    device = optarg;
	    break;
	case 'o':
	    file = optarg;
	    fdhandle = 1;
	    break;
	case 'd':
	    become_daemon = 1;
	    break;
	case 'v':
	    verbose = 1;
	    break;
	case 's':
	    status = 1;
	    break;
	case 'h':
	    usage(argv[0]);
	}
    }
    if (device == NULL)
	device = pcap_lookupdev(errbuf);

    printf("Using interface %s\n", device);
    if ((pd = pcap_open_live(device, BUFSIZ, 1, 0, errbuf)) == NULL) {
	printf("%s\n", errbuf);
	exit(1);
    }
    if(fdhandle){
	    if((fd = fopen(file,"a")) == NULL){
		    fprintf(stderr,"Can't Open %s\n",file);
		    exit(13);
	    }
    }else fd = stdout;
    signal(SIGHUP, closeup);
    signal(SIGINT, closeup);
	    
    switch (pcap_datalink(pd)) {
    case DLT_NULL:
	ETHHDRSIZE = 4;
	break;
    case DLT_EN10MB:
	ETHHDRSIZE = 14;
	break;
    case DLT_EN3MB:
	ETHHDRSIZE = 14;
	break;
    case DLT_PPP:
	ETHHDRSIZE = 4;
	break;
    case DLT_SLIP:
	ETHHDRSIZE = 16;
	break;
    case DLT_FDDI:
	ETHHDRSIZE = 21;
	break;
    case DLT_RAW:
	ETHHDRSIZE = 0;
	break;
    default:
	fprintf(stderr, "init_pcap : Unknown device type!\n");
	return (-1);
    }

    if ((pcap_lookupnet(device, &localnet, &netmask, errbuf)) < 0) {
	localnet = 0;
	netmask = 0;
	printf("%s\n", errbuf);
    }
    xpr = copy_argv(&argv[optind]);
    
    if (pcap_compile(pd, &fcode, xpr, 0, netmask) < 0)
	fprintf(stderr, "%s", pcap_geterr(pd));
    
    if (pcap_setfilter(pd, &fcode) < 0)
	fprintf(stderr, "%s", pcap_geterr(pd));
    printf("Starting At: %s\n", sniff_time());
    //is it to be daemonized ?
    if(become_daemon) daemonize();
    if ((pcap_loop(pd, -1, (pcap_handler) handlepkt, NULL)) < 0)
	fprintf(stderr, "pcap_loop: %s", pcap_geterr(pd));
    return (0);
}
void usage(char *proggie)
{
    fprintf(stderr,"Getdata Protocol Analyzer - Version[%s]\n",VER);
    fprintf(stderr,
	    "usage %s [h:d:v:s][ -i <interface> ] [ -o <outputfile> ] [expression]\n",
	    proggie);
    exit(1);
}
pcap_handler
handlepkt(u_char * args, struct pcap_pkthdr *pkthdr, u_char * mypacket)
{
    char *hand;
    char *tcpayload, *udpayload;
    struct iphdr *ip;
    struct udphdr *udp;
    struct icmphdr *icmp;
    struct igmphdr *igmp;
    struct riphdr *rip;
    struct in_addr porra;
    struct hostent *he;
    struct mytcphdr *tcp;
    static char sip[255];
    static char dip[255];
    register u_char flags; 

    int option_length = 0;

    ip = (struct iphdr *) (mypacket + ETHHDRSIZE);
    tcp =
	(struct mytcphdr *) (mypacket + ETHHDRSIZE + sizeof(struct iphdr) +
			   option_length);
    udp = (struct udphdr *) (mypacket + ETHHDRSIZE + sizeof(struct iphdr));
    icmp =
	(struct icmphdr *) (mypacket + ETHHDRSIZE + sizeof(struct iphdr));
    igmp =
	(struct igmphdr *) (mypacket + ETHHDRSIZE + sizeof(struct iphdr));
    rip =
	(struct riphdr *) (mypacket + ETHHDRSIZE + sizeof(struct iphdr) +
			   sizeof(struct udphdr));
    //hihi = (char *) (tcp + sizeof(tcp) - 3);
    //hehe = (char *) (tcp + sizeof(udp) - 12);
    //Our Payloads
    tcpayload =
	(u_char *) (mypacket + ETHHDRSIZE + sizeof(struct iphdr) +
		    sizeof(tcp));
    udpayload =
	(u_char *) (mypacket + ETHHDRSIZE + sizeof(struct iphdr) +
		    sizeof(udp));

    porra.s_addr = ip->saddr;
    he = gethostbyaddr((char *) &porra, sizeof(struct in_addr), AF_INET);
    if (he == NULL) {
	hand = (char *) inet_ntoa(porra);
	strncpy(sip, hand, sizeof(sip));
    } else {
	strncpy(sip, he->h_name, sizeof(sip));
    }
    porra.s_addr = ip->daddr;
    he = gethostbyaddr((char *) &porra, sizeof(struct in_addr), AF_INET);
    if (he == NULL) {
	hand = (char *) inet_ntoa(porra);
	strncpy(dip, hand, sizeof(dip));
    } else {
	strncpy(dip, he->h_name, sizeof(dip));
    }
    fflush(stdout);
    fprintf(fd,"\n[IP FRAME]\n");
    fprintf(fd,"IP Version:%u\n", (ip->version));
    fprintf(fd,"Time To Live:%u\n", (ip->ttl));
    fprintf(fd,"Source Address:%s\n", sip);
    fprintf(fd,"Destination Adress:%s\n", dip);
    fprintf(fd,"Length of Packet:%u bytes\n", htons(ip->tot_len));
    switch (ip->protocol) {
    case IPPROTO_TCP:
	fprintf(fd,"\n[TCP FRAME]\n");
	fprintf(fd,"Source Port:%u\n", ntohs(tcp->th_sport));
	fprintf(fd,"Destination Port:%u\n", ntohs(tcp->th_dport));
	fprintf(fd,"Sequence Number:%u\n", ntohl(tcp->th_seq));
	fprintf(fd,"Acknowledge Number:%u\n", ntohl(tcp->th_ack));
	fprintf(fd,"Checksum:0x%x\n", (tcp->th_sum));
	fprintf(fd,"Window:%u\n", (ntohs(tcp->th_win)));
	if((flags = (tcp->th_flags &(TH_SYN|TH_FIN|TH_RST|TH_PUSH)))){
		fprintf(fd,"Flags:");
		if(flags & TH_FIN)
			fprintf(fd,"FIN ");
		if(flags & TH_SYN)
			fprintf(fd,"SYN ");
		if(flags & TH_RST)
			fprintf(fd,"RST ");
		if(flags & TH_PUSH)
			fprintf(fd,"PUSH ");
		if(flags & TH_ACK)
			fprintf(fd,"ACK ");
	        if(flags & TH_URG)
			fprintf(fd,"URG ");
		fprintf(fd,"\n");
#ifdef DEBUG
		fprintf(fd,"Flags 0x%x\n",flags);
#endif
	}
	if(status)counttcp(ntohs(tcp->th_sport),ntohs(tcp->th_dport));
	lupatinadora++;
	fflush(fd);
	break;

    case IPPROTO_UDP:
	//printf("%s", hehe);
	fprintf(fd,"\n[UDP FRAME]\n");
	fprintf(fd,"Source Port:%u\n", ntohs(udp->source));
	fprintf(fd,"Destination Port:%u\n", ntohs(udp->dest));
	fprintf(fd,"Size of Packet:%u bytes\n", ntohs(udp->len));
	if(status) countudp(ntohs(udp->source),ntohs(udp->dest));
	lupatinadora++;
	fflush(fd);
	break;
    case IPPROTO_ICMP:
	fprintf(fd,"\n[ICMP FRAME]\n");
	fflush(fd);
	switch ((icmp->type)) {
	case 0:
	    fprintf(fd,"Type: Echo Reply\n");
	    break;
	case 3:
	    fprintf(fd,"Type: Destination Unreachable\n");
	    break;
	case 4:
	    fprintf(fd,"Type: Source Quench\n");
	    break;
	case 5:
	    fprintf(fd,"Type: Redirect (change route)\n");
	    break;
	case 8:
	    fprintf(fd,"Type: Echo Request\n");
	    break;
	case 11:
	    fprintf(fd,"Type: Time Exceeded\n");
	    break;
	case 12:
	    fprintf(fd,"Type: Parameter Problem \n");
	    break;
	case 13:
	    fprintf(fd,"Type: Timestamp Request\n");
	    break;
	case 14:
	    fprintf(fd,"Type: Information Request\n");
	    break;
	case 15:
	    fprintf(fd,"Type: Information Request\n");
	    break;
	case 16:
	    fprintf(fd,"Type: Information Reply  \n");
	    break;
	case 17:
	    fprintf(fd,"Type: Address Mask Request\n");
	    break;
	case 18:
	    fprintf(fd,"Type: Address Mask Reply\n");
	    break;
	default:
	    fprintf(fd,"\aType:UNKNOW TYPE\n");
	}
	fprintf(fd,"Checksum:0x%x\n", ntohs(icmp->checksum));
	if(status)counticmp((icmp->type));
	lupatinadora++;
	fflush(fd);
	break;
    case IPPROTO_IGMP:
	fprintf(fd,"\n[IGMP FRAME]\n");
	switch ((igmp->type)) {
	case 0x11:
	    fprintf(fd,"Type: IGMP Host Membership Query\n");
	    break;
	case 0x12:
	    fprintf(fd,"Type: IGMP Host Membership Report\n");
	    break;
	case 0x13:
	    fprintf(fd,"Type: IGMP DVMRP (dvmrp routing)\n");
	    break;
	case 0x14:
	    fprintf(fd,"Type: IGMP PIM (pim routing)\n");
	    break;
	case 0x15:
	    fprintf(fd,"Type: IGMP TRACE\n");
	    break;
	case 0x16:
	    fprintf(fd,"Type: IGMP Host New Membership Report\n");
	    break;
	case 0x17:
	    fprintf(fd,"Type: IGMP Host Leave Messages\n");
	    break;
	case 0x1e:
	    fprintf(fd,"Type: IGMP Mtrace Resp\n");
	    break;
	case 0x1f:
	    fprintf(fd,"Type: IGMP Mtrace\n");
	    break;
	default:
	    fprintf(fd,"\aType: UNKNOW\n");
	}
	fprintf(fd,"Checksum:0x%x\n", ntohs(igmp->csum));
	fprintf(fd,"Group:%u\n", ntohl(igmp->group));
	lupatinadora++;
	fflush(fd);
	break;
    default:
	fprintf(fd,"Protocol UNKNOWN\n");
    }
    return (0);
}

//Fuction of Tcpdump / utils.c
char *copy_argv(register char **argv)
{
    register char **p;
    register u_int len = 0;
    char *buf;
    char *src, *dst;

    p = argv;
    if (*p == 0)
	return 0;

    while (*p)
	len += strlen(*p++) + 1;

    buf = (char *) malloc(len);
    if (buf == NULL)
	perror("copy_argv: malloc");

    p = argv;
    dst = buf;
    while ((src = *p++) != NULL) {
	while ((*dst++ = *src++) != '\0');
	dst[-1] = ' ';
    }
    dst[-1] = '\0';

    return buf;
}

void closeup(int u)
{
    if(fdhandle) fclose(fd);
    printf("\nStop At: %s\n", sniff_time());
    printf("Packets Received: %d\n", lupatinadora);
    if(status && lupatinadora > 0){
	unsigned int tcptotal = ourtcp.others + ourtcp.ftp + ourtcp.telnet + ourtcp.smtp + ourtcp.http + ourtcp.pop3 + ourtcp.https;
	unsigned int udptotal = ourudp.others + ourudp.dns + ourudp.tftp;  
	unsigned int icmptotal = ouricmp.echoreply+ouricmp.dest_unreach+ouricmp.source_quench+ouricmp.redirect+ouricmp.echo+ouricmp.time_exceeded+ouricmp.parameterprob+ouricmp.timestamp+ouricmp.timestampreply+ouricmp.info_request+ouricmp.info_reply+ouricmp.addrmask_req+ouricmp.addrmask_repl+ouricmp.others;
	printf("-=[ Traffic Statistics ]=----------------------------------\n");
	if(tcptotal){
    		printf("TCP Total: %u (%u%%)\n",tcptotal,calc(lupatinadora,tcptotal));		if(ourtcp.ftp)
    		printf("\tFtp Total: %u (%u%%)\n",ourtcp.ftp,calc(tcptotal,ourtcp.ftp));
		if(ourtcp.telnet)
    		printf("\tTelnet Total: %u (%u%%)\n",ourtcp.telnet,calc(tcptotal,ourtcp.telnet));
		if(ourtcp.smtp)
    		printf("\tSmtp Total: %u (%u%%)\n",ourtcp.smtp,calc(tcptotal,ourtcp.smtp));	if(ourtcp.http)
    		printf("\tHttp Total: %u (%u%%)\n",ourtcp.http,calc(tcptotal,ourtcp.http));
		if(ourtcp.pop3)
    		printf("\tPop3 Total: %u (%u%%)\n",ourtcp.pop3,calc(tcptotal,ourtcp.pop3));
		if(ourtcp.https)
    		printf("\tHttps Total: %u (%u%%)\n",ourtcp.https,calc(tcptotal,ourtcp.https));
		if(ourtcp.others)
    		printf("\tTCP others: %u (%u%%)\n",ourtcp.others,calc(tcptotal,ourtcp.others));
	}
	if(udptotal){
		printf("UDP Total: %u (%u%%)\n",udptotal,calc(lupatinadora,udptotal));
		if(ourudp.dns)
		printf("\tDns Total: %u (%u%%)\n",ourudp.dns,calc(udptotal,ourudp.dns));
		if(ourudp.tftp)
		printf("\tTftp Total: %u (%u%%)\n",ourudp.tftp,calc(udptotal,ourudp.tftp));
		if(ourudp.others)
		printf("\tUDP others: %u (%u%%)\n",ourudp.others,calc(udptotal,ourudp.others));
	}
	if(icmptotal){
		printf("ICMP Total: %u (%u%%)\n",icmptotal,calc(lupatinadora,icmptotal));
		if(ouricmp.echo)
		printf("\tICMP Echo Request: %u (%u%%)\n",ouricmp.echo,calc(icmptotal,ouricmp.echo));
		if(ouricmp.echoreply)
		printf("\tICMP Echo Reply: %u (%u%%)\n",ouricmp.echoreply,calc(icmptotal,ouricmp.echoreply));
		if(ouricmp.dest_unreach)
		printf("\tICMP Destination Unreachable: %u (%u%%)\n",ouricmp.dest_unreach,calc(icmptotal,ouricmp.dest_unreach));
		if(ouricmp.source_quench)
		printf("\tICMP Source Quench: %u (%u%%)\n",ouricmp.source_quench,calc(icmptotal,ouricmp.source_quench));
		if(ouricmp.redirect)
		printf("\tICMP Redirect: %u (%u%%)\n",ouricmp.redirect,calc(icmptotal,ouricmp.redirect));
		if(ouricmp.time_exceeded)
		printf("\tICMP TimeExceeded: %u (%u%%)\n",ouricmp.time_exceeded,calc(icmptotal,ouricmp.time_exceeded));
	}
    }
    if (pcap_stats(pd, &st) < 0) {
	pcap_perror(pd, "pcap error: ");
	exit(1);
    } else
	printf("Packets dropped by interface: %d\n", st.ps_drop);
    exit(1);
}
